/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Message section.  Underlying framework.                                *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#define INITIALIZE_MSG    /* Intialize message-area variables */

#include <stdio.h>
#include <dos.h>
#include <errno.h>
#include <io.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
#include <time.h>
#include <string.h>
#include "prog.h"
#include "ffind.h"
#include "alc.h"
#include "max.h"
#include "max_msg.h"

int pascal IsValidMsgArea(struct _area *a,int areanum);
static void near pascal Scan_LastRead_Pointer(void);
void pascal Scan_Msg_Numbers(int get_high);
static char * near pascal MsgDate(struct _msg *msg,char *datebuf);
static void near pascal Update_Scanfile(int mode,int msgnum,int scanfile);


int pascal Msg_Area(void)
{
  int savearea;

  savearea=usr.msg;

  while (1)
  {
    barricade_ok=FALSE;
    FixMenuPath();
    Msg_Area_Menu();

    if (! IsValidMsgArea(NULL,usr.msg))
    {
      logit(denied_access,s(msg_abbr),Area_Name(usr.msg),areatag);

      usr.msg=savearea;

      if (*PRM(areanotexist))
        Display_File(0,NULL,PRM(areanotexist));
      else Puts(areadoesntexist);

      continue;
    }

    logit(s(log_msga),Area_Name(usr.msg),areatag);

    if (*area.msgbar)
      Barricade(TRUE);
    else
    {
      barricade_priv=usr.priv;
      barricade_ok=TRUE;
    }

    if (! *area.msgbar || barricade_ok)
      break;
    else if (barricade_priv==0x1234)
    {
      barricade_priv=usr.priv;

      if (*PRM(areanotexist))
        Display_File(0,NULL,PRM(areanotexist));
      else Puts(areadoesntexist);
    }
  }

  if (Save_Directory(area.msgpath)==-1)
  {
    logit(mem_ndir);
    Puts(mem_ndir);
    quit(ERROR_recycle);
  }

  entry=ENTRY_nochecke;

  return barricade_priv;
}


void pascal Msg_Area_Menu(void)
{
  struct _aidx aidx;
  struct _area carea;

  int first;

  char temp[PATHLEN],
       string[PATHLEN],
       wrapped;

  long y;

  WhiteN();

  first=TRUE;

  while (1)
  {
    barricade_ok=FALSE;  /* Reset barricade counter on A)rea cmd */

    Puts(WHITE);
    
    sprintf(string,s(msg_prmpt),PRM(achg_keys)[0],PRM(achg_keys)[1],
            PRM(achg_keys)[2]);

    OpusGets(temp,string);
    strupr(temp);

    if (*temp=='\'' || *temp=='`')
      Display_File(0,NULL,ss,PRM(misc_path),quotes_misunderstood);
    else if (*temp=='#')              /* Maybe the user misunderstood? */
      Display_File(0,NULL,ss,PRM(misc_path),numsign_misunderstood);
    else if (*temp==PRM(achg_keys)[1] || *temp==']' || *temp=='>' ||
             *temp=='+')
    {
      wrapped=FALSE;
      strcpy(linebuf,temp+1);

      /* If we can't find our area, then return...  This call will         *
       * position the `areasidx' file pointer correctly...                 */

      if (Index_of_Area(usr.msg)==-1L)
        return;

      /* Skip over current area */
      lseek(areasidx,(long)sizeof(struct _aidx),SEEK_CUR);

      while (1)
      {
        /* Loop while there are still index entries */
        for (y=1;y > 0;)
        {
          /* Now get the next index entry... */

          y=read(areasidx,(char *)&aidx,sizeof(struct _aidx));

          lseek(areasfile,aidx.offset,SEEK_SET);
          read(areasfile,(char *)&carea,sizeof(struct _area));

          if (aidx.area <= prm.high_msgarea && IsValidMsgArea(&carea,0) &&
              ExtBarricadeOK(&carea,TRUE,NULL))
          {
            usr.msg=carea.areano;          /* Found the right area... */
            return;
          }
        }

        if (!wrapped)   /* If we wrap around... */
        {
          wrapped=TRUE;
          lseek(areasidx,0L,SEEK_SET);
        }
        else return;
      }
    }
    else if (*temp==PRM(achg_keys)[0] || *temp=='[' || *temp=='<' ||
             *temp=='-')
    {
      wrapped=FALSE;
      strcpy(linebuf,temp+1);

      /* If we can't find our area, then return...  This call will         *
       * position the `areasidx' file pointer correctly...                 */

      if (Index_of_Area(usr.msg)==-1L)
        return;

      while (1)
      {
        /* Loop while there are still index entries */

        for (y=1;y != 0;)
        {
          /* Now get the next index entry... */

          y=lseek(areasidx,-(long)sizeof(struct _aidx),SEEK_CUR);

          if (y < 0)
            break;

          read(areasidx,(char *)&aidx,sizeof(struct _aidx));
          lseek(areasidx,-(long)sizeof(struct _aidx),SEEK_CUR);

          lseek(areasfile,aidx.offset,SEEK_SET);
          read(areasfile,(char *)&carea,sizeof(struct _area));

          if (aidx.area <= prm.high_msgarea && IsValidMsgArea(&carea,0) &&
              ExtBarricadeOK(&carea,TRUE,NULL))
          {
            usr.msg=carea.areano;          /* Found the right area... */
            return;
          }
        }

        if (!wrapped)   /* If we wrap around... */
        {
          wrapped=TRUE;
          lseek(areasidx,0L,SEEK_END);
        }
        else return;
      }
    }
    else if (*temp==PRM(achg_keys)[2] || *temp=='?' || *temp=='/')
    {
      strcpy(linebuf,temp+1);
      List_Message_Areas();
    }
    else if (! *temp ||
            (temp[0] >= '0' && temp[0] <= '9') ||
            (temp[0] >= 'A' && temp[0] <= 'Z'))
    {
      if (*temp)
      {
        usr.msg=Set_Area_Name(temp);
        return;
      }
      else if (first)
        List_Message_Areas();
      else return;
    }
    else Printf(dontunderstand,temp[0]);

    first=FALSE;
  }
}


/* This routine finds all of the messages in the area, and gets the user's *
 * LASTREAD pointer.                                                       */

void pascal Msg_Area_Scan(void)
{
  Scan_Msg_Numbers(FALSE);
  Scan_LastRead_Pointer();
}










void pascal Recd_Msg(int msgfile,struct _msg *msg,int msgnum,int scanfile)
{
  if (eqstri(msg->to,usr.name) && !(msg->attr & MSGREAD))
  {
    lseek(msgfile,0L,SEEK_SET);
    msg->attr |= MSGREAD;
    write(msgfile,(char *)msg,sizeof(struct _msg));

    Update_Scanfile(0,msgnum,scanfile);
  }
}










int pascal Ask_KillMsg(struct _msg *msg)
{
  if (msg->attr & MSGPRIVATE)
  {
    switch (prm.auto_kill)
    {
      case 0:               /* Don't kill message */
        return FALSE;

      case 1:               /* Ask if we should kill message */
        WhiteN();

        if (GetyNAnswer(s(del_msg),0)==YES)
        {
          Putc('\n');
          return TRUE;
        }
        else return FALSE;

      case 2:               /* Automatically kill message */
        return TRUE;
    }
  }

  return FALSE;
}





int pascal MsgToUs(int zone,int net,int node)
{
  int x;

  for (x=0;x < ALIAS_CNT;x++)
  {
    if ((zone==0 || prm.address[x].Zone==zone) && net==prm.address[x].Net &&
        node==prm.address[x].Node)
      return TRUE;
  }

  return FALSE;
}


int pascal Msg_Display(int msgfile,struct _msg *msg,int pause,int areano,int msgnum,int offset)
{
  int save_x,     /* Used to temporarily save cursor position. */
      x,y,z,
      ret,
      moremsg,
      msgoffset;  /* Screen line on which the message body starts.  This   *
                   * is important if we have more than one page, and we're *
                   * displaying a matrix address, which bumps everything   *
                   * down by one line.                                     */

  char string[MAXLEN],
       *outline[MAX_MSGDISPLAY],  /* The output message line */
       linetype[MAX_MSGDISPLAY],  /* Type for that line */
       break_loop,
       last_msg_attr,
       do_chain,  /* If we should display the '*** This is a reply to #xx' chains for this msg. */
       nonstop,   /* If the user entered a '=' for non-stop */
       paged;     /* If more than one page of message was displayed */

  for (x=0;x < MAX_MSGDISPLAY;x++)
    if ((outline[x]=malloc(MAX_LINELEN*sizeof(char)))==NULL)
    {
      logit(mem_nmsgb);
      
      for (y=0;y < x;y++)
        free(outline[y]);
      
      return -2;
    }
     
  ret=0;
  msgoffset=5+offset;                     /* Default starting line */
  msgeof=nonstop=break_loop=paged=FALSE;
  last_msg_attr=0;

  /* Remove any nasty ANSI codes from the message header! */
  Strip_Ansi(msg->from,areano,msgnum);
  Strip_Ansi(msg->to,areano,msgnum);
  Strip_Ansi(msg->subj,areano,msgnum);

  msg->to[35]='\0';
  msg->from[35]='\0';
  msg->subj[71]='\0';

  if (graph != GRAPHICS_none && usr.formfeed==0)
    Putc('\n');

  sprintf(string,s(mfrom),msg->from);

  for (y=1,x=0;x < 16;y<<=1,x++)
    if ((msg->attr & y) && y != MSGLOCAL)
      if (strlen(string)+strlen(attributes[x]) < MAXLEN)
      {
        strcat(string,attributes[x]);
        strcat(string," ");
      }

  Puts(string);
  Putc('\n');

  if (CheckTrap())
  {
    ret=-1;
    goto EndMsgDisplay;
  }

  Display_Addr(orig_addr,s(net_orig),&msgoffset,msg->orig_net,msg->orig);

  Printf(s(mto),msg->to,msgnum,MsgDate(msg,string));

  if (CheckTrap())
  {
    ret=-1;
    goto EndMsgDisplay;
  }

  Display_Addr(dest_addr,s(net_dest),&msgoffset,msg->dest_net,msg->dest);

  Printf(CYAN "%s" YELLOW " %0.*s\n\n" CYAN,
         (msg->attr & (MSGFILE | MSGFRQ | MSGURQ)) ? files_colon : subj_colon,
         usr.width-10,msg->subj);

  if (CheckTrap())
  {
    ret=-1;
    goto EndMsgDisplay;
  }

  display_line=(char)(msgoffset+(usr.help==HOTFLASH ? 1 : 0));
  display_col=1;

  while (1)
  {
    /* If we got some lines line */
    if ((y=Msg_Read_Lines(msgfile,MAX_MSGDISPLAY,usr.width-1,outline,
                          linetype,&last_msg_attr)) > 0)
    {
      for (x=0;x < y;x++)
      {
        /* If we're near the end of the message, strip excess blank lines */

        if (x >= (y-5) && (linetype[y==MAX_MSGDISPLAY ? y-1 : y] & MSGLINE_end))
        {
          moremsg=FALSE;

          for (z=x;z < y;z++)
            if (! isnl(outline[z]) ||
                ((linetype[z] & MSGLINE_seenby) && GEPriv(usr.priv,prm.seenby_priv)) ||
                ((linetype[z] & MSGLINE_kludge) && GEPriv(usr.priv,prm.ctla_priv)))
            {
              moremsg=TRUE;
              break;
            }

          if (!moremsg)
            goto BrokeLoop;
        }

        if (linetype[x] & MSGLINE_seenby)
        {
          if (! GEPriv(usr.priv,prm.seenby_priv))
            continue;
        }
        else if (linetype[x] & MSGLINE_kludge)
        {
          if (! GEPriv(usr.priv,prm.ctla_priv))
            continue;
          else Puts(YELONBLUE);
        }
        else if (linetype[x] & MSGLINE_quote)
          Puts(GRAY);
        else Puts(CYAN);

        Puts(CLEOL);
        Puts(outline[x]);

        if (linetype[x] & MSGLINE_kludge)
          Puts(CYAN);

        Putc('\n');

        if (CheckTrap())
        {
          ret=-1;
          goto EndMsgDisplay;
        }

        if (display_line >= usr.len-(usr.help==HOTFLASH ? 0 : 1) &&
            pause && !nonstop)
        {
          Puts(CYAN);

          switch (MoreYnns_Read())
          {
            case YES:
              break;

            case M_NONSTOP:
              nonstop=TRUE;
              break;

            case NO:
              break_loop=TRUE;
              break;
          }

          if (!nonstop && graph != GRAPHICS_none && usr.formfeed)
          {
            paged=TRUE;
            Printf("\x16\x08%c\x01" CLEOL,msgoffset);  /* Go to below msg. header */
          }
          else display_line=1;
        }

        if (break_loop)
          break;
      }

      if (break_loop)
        break;
    }
    else break;
  }

BrokeLoop:

  do_chain=TRUE;

  if (break_loop)
    do_chain=FALSE;

  if (display_line >= usr.len-1 && pause && !nonstop)
  {
    if (!break_loop)
    {
      break_loop=FALSE;

      Puts(CYAN CLEOL);

      switch (MoreYnns_Read())
      {
        case M_NONSTOP:
          nonstop=TRUE;
          do_chain=TRUE;
          break;

        case YES:
          do_chain=TRUE;
          break;

        case NO:
          break_loop=TRUE;
          do_chain=FALSE;
          break;
      }

      if (! nonstop && graph != GRAPHICS_none && usr.formfeed &&
          do_chain)
      {
        paged=TRUE;
        Printf("\x16\x08%c\x01" CLEOL,msgoffset);  /* Goto below msg. header */
      }
    }
  }


  /* Clear the rest of the page, if we scrolled using graphics */

  if (paged)
  {
    save_x=current_line;

    /* Clear rest of screen */
    Printf(CYAN "\x16\x19\x03" CLEOL "\n%c",
           usr.len-current_line);

    Goto(save_x,'\x01');
  }

  if (do_chain)
  {
    if (msg->reply)
    {
      Printf(s(this_reply),msg->reply);

      if (msg->up)
        Printf(s(see_also),msg->up);
      else Putc('\n');
    }
    else if (msg->up)
      Printf(s(there_reply),msg->up);
  }

  if (!nonstop && pause && !break_loop &&
      (display_line > usr.len-(menu_lines+4) && pause && !nonstop &&
      !break_loop))
  {
    if (do_chain && display_line < usr.len-1)
      Putc('\n');

    Press_ENTER_Read();
  }

EndMsgDisplay:

  for (x=0;x < MAX_MSGDISPLAY;x++)
    free(outline[x]);
  
  return ret;
}


void pascal Display_Addr(char *orig_or_dest,char *type,int *msgoffset,int net,int node)
{
  struct _node nnode;        /* Both types of nodelist structures... */
  struct _newnode newnode;

  if (area.attrib[class] & SYSMAIL)
  {
    if (! MsgToUs(0,net,node))
    {
      if (ReadNode(0,net,node,prm.nlver==6 ? (void *)&newnode : (void *)&nnode))
      {
        if (prm.nlver==6)
          Printf(addrfmt,orig_or_dest,newnode.SystemName,newnode.NetNumber,
                 newnode.NodeNumber,newnode.MiscInfo);
        else Printf(addrfmt,orig_or_dest,nnode.name,nnode.net,nnode.number,nnode.city);
      }
      else Printf(unlisted_system,type,net,node);

      (*msgoffset)++;
    }
  }
}


int pascal CheckTrap(void)
{
  if (brk_trapped || mdm_halt())
  {
    brk_trapped=0;
    Putc('\n');
    mdm_dump(DUMP_all);
    Clear_KBuffer();
    return 1;
  }

  return 0;
}




void pascal List_Message_Areas(void)
{
  struct _aidx aidx;
  struct _area carea;

  int x;

  char nonstop,
       temp[PATHLEN];


  if (*PRM(msgarea_list))
    Display_File(0,NULL,PRM(msgarea_list));
  else
  {
    nonstop=FALSE;

    Puts(CLS);

    display_line=display_col=1;
    inmsgarea=TRUE;

    Parse_Custom_Area_Listing(NULL,PRM(msg_header),temp,TRUE);
    Puts(temp);

    lseek(areasidx,0L,SEEK_SET);

    while (1)
    {
      x=read(areasidx,(char *)&aidx,sizeof(struct _aidx));

      if (x)
      {
        lseek(areasfile,aidx.offset,SEEK_SET);
        read(areasfile,(char *)&carea,sizeof(struct _area));

        if (aidx.area <= prm.high_msgarea && IsValidMsgArea(&carea,0) &&
            ExtBarricadeOK(&carea,TRUE,NULL))
        {
          Parse_Custom_Area_Listing(&carea,PRM(msg_format),temp,FALSE);
          Puts(temp);
        }

        if (brk_trapped || mdm_halt())
        {
          brk_trapped=0;
          mdm_dump(DUMP_all);
          break;
        }

        if (MoreYnBreak(&nonstop,CYAN))
          break;
      }
      else break;
    }
    
    Parse_Custom_Area_Listing(NULL,PRM(msg_footer),temp,FALSE);
    Puts(temp);

    Putc('\n');
  }
}

/* Update the user's lastread pointer in the LASTREAD.BBS file for each
   area.                                                                  */

void pascal Fix_Lastread(void)
{
  char temp[PATHLEN];

  int lastreadfile,
      tempint;

  long offset;

  /* If it hasn't changed, don't update it! */
  if (last_lastread==last_msg)
    return;

  sprintf(temp,usr.lastread_ptr ? ps_lastread : ps_lastread_single,area.msgpath);

  /* Open and/or create the file as necessary */

  if ((lastreadfile=sopen(temp,O_CREAT | O_RDWR | O_BINARY,SH_DENYNONE,S_IREAD | S_IWRITE))==-1)
    logit(cantopen,temp);
  else
  {
    lseek(lastreadfile,0L,SEEK_END);

    if (tell(lastreadfile) < (offset=usr.lastread_ptr*sizeof(int)))   /* Have to write some zeros. */
    {
      tempint=0;

      while (tell(lastreadfile) < offset)         /* Write zeros... */
      {
        if (write(lastreadfile,(char *)&tempint,sizeof(int)) != sizeof(int))
        {
          logit(cantwrite,temp);
          close(lastreadfile);
          return;
        }
      }
    }

    lseek(lastreadfile,offset,SEEK_SET);

    if (write(lastreadfile,(char *)&last_msg,sizeof(int)) <= 0)   /* If no disk space */
      logit(cantwrite,temp);

    close(lastreadfile);
  }
}


#define ISVMSGA_FAR
#define SCANM_FAR

#include "isvma.c"
#include "lread.c"
#include "msgdate.c"
#include "updsf.c"

